/*
 * generated by Xtext
 */
package es.uca.webservices.testgen.parsers.spec.xtext.formatting;

import org.eclipse.xtext.Keyword;
import org.eclipse.xtext.formatting.impl.AbstractDeclarativeFormatter;
import org.eclipse.xtext.formatting.impl.FormattingConfig;

import es.uca.webservices.testgen.parsers.spec.xtext.services.TestSpecGrammarAccess;

/**
 * This class contains custom formatting description.
 * 
 * see : http://www.eclipse.org/Xtext/documentation/latest/xtext.html#formatting
 * on how and when to use it 
 * 
 * Also see {@link org.eclipse.xtext.xtext.XtextFormattingTokenSerializer} as an example
 */
public class TestSpecFormatter extends AbstractDeclarativeFormatter {
	
	@Override
	protected void configureFormatting(FormattingConfig c) {
		final TestSpecGrammarAccess g = (TestSpecGrammarAccess)getGrammarAccess();

		// It's usually a good idea to activate the following three statements.
		// They will add and preserve newlines around comments.
		c.setLinewrap(0, 1, 2).before(g.getSL_COMMENTRule());
		c.setLinewrap(0, 1, 2).before(g.getML_COMMENTRule());
		c.setLinewrap(0, 1, 1).after(g.getML_COMMENTRule());
		
		// No spaces before semicolons
		for (Keyword kw : g.findKeywords(";")) {
			c.setNoSpace().before(kw);
		}
		
		// No space before commas, single space after them
		for (Keyword kw : g.findKeywords(",")) {
			c.setNoSpace().before(kw);
			c.setSpace(" ").after(kw);
		}
		
		// Single space before and after equal signs
		for (Keyword kw : g.findKeywords("=")) {
			c.setSpace(" ").before(kw);
			c.setSpace(" ").after(kw);
		}
	}
}
